(function() {

	"use strict";

	var base64Img = require("base64-img"),
		walk = require("walk"),
		fs = require("fs"),
		imagesPath = __dirname + "/icons",
		targetFile = __dirname + "/../source/data/images.js",
		output,
		imageExtensions = ["png", "svg"];

	output = "(function(module) { module.exports = {\n" +
		"// This file is automatically generated - do not alter\n";

	var walker  = walk.walk(imagesPath, { followLinks: false });

	walker.on('file', function(root, stat, next) {
		//files.push(root + '/' + stat.name);
		var extension = stat.name.split(".").pop().toLowerCase();
		if (imageExtensions.indexOf(extension) >= 0) {
			var imageName = stat.name.substr(0, stat.name.length - 1 - extension.length);
			console.log("Image:", imageName);
			output += imageName + ":'" + base64Img.base64Sync(root + "/" + stat.name) + "',\n";
		}
		next();
	});

	walker.on('end', function() {
		output += "}; })(module);";
		fs.writeFile(targetFile, output, function(err) {
			if (err) {
				console.error(err);
				throw err;
			}
		});
	});

})();
